#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <allegro.h>

BEGIN_GFX_DRIVER_LIST
END_GFX_DRIVER_LIST
BEGIN_COLOR_DEPTH_LIST
 COLOR_DEPTH_8
END_COLOR_DEPTH_LIST
BEGIN_DIGI_DRIVER_LIST
END_DIGI_DRIVER_LIST
BEGIN_MIDI_DRIVER_LIST
END_MIDI_DRIVER_LIST
BEGIN_JOYSTICK_DRIVER_LIST
END_JOYSTICK_DRIVER_LIST

typedef unsigned char  Uint8;
typedef unsigned short Uint16;

char *file_fon, *file_bmp;

int fon2bmp( void );
int bmp2fon( void );

int main( int argc, char *args[] )
{
 char *name;

  allegro_init();
  set_color_depth( 8 );

  if( argc != 2 )
    {
     printf( "Usage: %s file.{fon|bmp}\n", args[0] );
     printf( "If you choose a *.raw file ou obtain a *.bmp\n"
             "If you choose a *.bmp file ou obtain a *.raw\n"
             "\n"
             "Choose now a file? " );
     name = (char*) malloc( 200 );
     scanf( "%s", name );
    }
   else
    {
     name = args[1];
    }


       if( strcmp( name+strlen(name)-4, ".fon" ) == 0 )
          {
           file_fon = name;
           file_bmp = strdup( name );
           file_bmp[strlen(name)-3] = 'b'; // barbarian
           file_bmp[strlen(name)-2] = 'm';
           file_bmp[strlen(name)-1] = 'p';
           return fon2bmp();
          }
  else if( strcmp( name+strlen(name)-4, ".bmp" ) == 0 )
          {
           file_bmp = name;
           file_fon = strdup( name );
           file_fon[strlen(name)-3] = 'f'; // barbarian
           file_fon[strlen(name)-2] = 'o';
           file_fon[strlen(name)-1] = 'n';
           return bmp2fon();
          }
  printf( "Input file aren't *.fon nor *.bmp\n" );

  return 1;
}
#ifndef DJGPP
END_OF_MAIN();
#endif


int fon2bmp( void )
  {
   Uint8 n, h, w;
   Uint16 total_w = 0, x;
   int col, i;
   BITMAP **font;
   BITMAP *total;
   PALETTE pal;
   FILE *fd;

   fd = fopen( file_fon, "rb" );
   if( fd == NULL ) { printf( "ERR: Can't open file %s\n", file_fon ); exit(1); }

   fread( &n, 1, 1, fd );
   fread( &h, 1, 1, fd );

   font = (BITMAP**) malloc( n * sizeof(BITMAP*) );
   for( i=0 ; i<n ; i++ )
     {
      Uint8 *buff;
      fread( &w, 1, 1, fd );
      buff = (Uint8*) malloc( w*h );
      font[i] = create_bitmap_ex( 8, w, h );
      fread( &(font[i]->line[0][0]), w*h, 1, fd );
      total_w += w;
     }

   for( i=0 ; i<256 ; i++ )
     {
      fread( &(pal[i]), 1, 3, fd );
      pal[i].r /= 4;
      pal[i].g /= 4;
      pal[i].b /= 4;
     }
   set_palette( pal );

   fclose( fd );

   total = create_bitmap_ex( 8, total_w+n, h );
   x = 0;
   col = makecol8(255,0,0);
   for( i=0 ; i<n ; i++ )
     {
      Uint8 y;
      blit( font[i], total, 0, 0, x, 0, font[i]->w, font[i]->h );
      x += font[i]->w;
      for( y=0 ; y<h ; y++ ) total->line[y][x] = col;
      x++;
     }

   printf( "%s --> %s\n", file_fon, file_bmp );
   printf( "Detect: number=%i, height=%i\n", n, h );
   save_bitmap( file_bmp, total, pal );

   return 0;
  }

int bmp2fon( void )
  {
   PALETTE pal;
   BITMAP *total;
   FILE *fd;
   Uint16 x, ax, i;
   int col;
   Uint8 n, h;
   char c;

   total = load_bmp( file_bmp, pal );
   if( total == NULL ) { printf( "ERR: Can't read %s (probably not indexed)\n", file_bmp ); exit(1); }
   set_palette( pal );
   col = makecol8(255,0,0);
   h = total->h;

   fd = fopen( file_fon, "w+b" );
   if( fd == NULL ) { printf( "ERR: Can't write file %s\n", file_fon ); exit(1); }

   fwrite( pal, 1, 1, fd ); // write only one byte
   fwrite( (char*)&(total->h), 1, 1, fd );

   x = 0;
   n = 0;
   do
     {
      BITMAP *font;
      Uint8 y;
      ax = x;
      do
        {
         y = 0;
         while( x<total->w && total->line[0][x] != col ) x++;
         while( y<h && total->line[y][x] == col ) y++;
         x++;
        }
      while( x < total->w && y != h );

      n++;

      c = x-ax-1;
      printf( "Picture %i : w=%i\n", n, c );
      fwrite( &c, 1, 1, fd );

      font = create_bitmap_ex( 8, c, h );
      blit( total, font, ax, 0, 0, 0, c, h );

      fwrite( &(font->line[0][0]), c*h, 1, fd );

     }
   while( x < total->w );

   for( i=0 ; i<256 ; i++ )
     {
      pal[i].r *= 4;
      pal[i].g *= 4;
      pal[i].b *= 4;
      fwrite( &(pal[i]), 1, 3, fd );
     }

   fseek( fd, 0, SEEK_SET );
   fwrite( &n, 1, 1, fd );

   fclose( fd );

   printf( "%s --> %s\n", file_bmp, file_fon );
   return 0;
  }
